
#pragma once

#ifndef POINT_SET_HPP
#define POINT_SET_HPP

#include "bezier/vec2.hpp"
#include "bezier/bezier.hpp"


#include <QPainter>



class bezier_drawer
{
public:

    bezier_drawer();
    void draw_control_polygon_line(QPainter& painter,float w,float h) const;
    void draw_control_polygon_points(QPainter& painter,float w,float h) const;
    void draw_control_polygon_point(QPainter& painter,int vertex_selected,int w,int h) const;
    void draw_bezier_line(QPainter& painter,float w,float h) const;

    int get_closest_vertex_control(int x,int y,float w,float h,float threshold) const;
    void translate_vertex(int index,int x,int y);

private:

    bezier<vec2> data;
};

vec2 coord_to_axis_convert(const vec2& p,float w,float h);
vec2 axis_to_coord_convert(const vec2& p,float w,float h);

#endif
