
#include "render_area.hpp"

#include <GL/glu.h>
#include <iostream>

#include <QPainter>
#include <QMouseEvent>


render_area::render_area(QWidget *parent)
    :QWidget(parent)
{
    //fond blanc
    setBackgroundRole(QPalette::Base);
    setAutoFillBackground(true);


    vertex_selected=-1;

}

render_area::~render_area()
{}



void render_area::paintEvent(QPaintEvent*)
{
    //la classe qui permet de "dessiner"
    QPainter painter(this);
    painter.setRenderHint(QPainter::Antialiasing, true);

    //le pinceau de dessin
    QPen pen;

    const float w=this->width();
    const float h=this->height();


    pen.setWidth(1.0);
    pen.setColor(Qt::black);
    painter.setPen(pen);
    data.draw_control_polygon_line(painter,w,h);


    pen.setWidth(5.0);
    pen.setColor(Qt::red);
    painter.setPen(pen);
    data.draw_control_polygon_points(painter,w,h);


    if(vertex_selected!=-1)
    {
        pen.setWidth(5.0);
        pen.setColor(Qt::yellow);
        painter.setPen(pen);
        data.draw_control_polygon_point(painter,vertex_selected,w,h);
    }

    pen.setWidth(1.0);
    pen.setColor(Qt::blue);
    painter.setPen(pen);
    data.draw_bezier_line(painter,w,h);

}

//souris appuyee qui se deplace
void render_area::mouseMoveEvent(QMouseEvent *event)
{
    int x=event->x();
    int y=event->y();

    if(vertex_selected!=-1)
    {
        int tr_x=x-x_old;
        int tr_y=y-y_old;


        data.translate_vertex(vertex_selected,tr_x,tr_y);

        x_old=x;
        y_old=y;

    }


    repaint();
}

//simple click souris
void render_area::mousePressEvent(QMouseEvent *event)
{
    int x=event->x();
    int y=event->y();


    vertex_selected=data.get_closest_vertex_control(x,y,this->width(),this->height(),0.3);
    if(vertex_selected!=-1)
    {
        x_old=x;
        y_old=y;
    }

    repaint();
}

