#pragma once

#ifndef RENDER_AREA_HPP
#define RENDER_AREA_HPP



#include <QWidget>
#include <QPixmap>
#include <QBrush>
#include <QPen>
#include <QTime>

#include <vector>

#include "bezier/objet_geometrique.hpp"
#include "bezier/vec2.hpp"



class render_area : public QWidget
{
    Q_OBJECT
public:
    render_area(QWidget *parent = 0);
    ~render_area();

    void init_fig();


protected:
     void paintEvent(QPaintEvent *event);

     void mouseMoveEvent(QMouseEvent *event);
     void mousePressEvent(QMouseEvent *event);
     void mouseReleaseEvent(QMouseEvent *event);

private:

     QPixmap pixmap;

     std::vector<objet_geometrique*> objects;
     std::vector<std::vector<vec2> > point_sets;

     vec2 coord_to_axis(const vec2& p) const;
     vec2 axis_to_coord(const vec2& p) const;


     int is_closest;
     vec2 closest_point;
     vec2 mouse_point;
     bool is_init;
     bool is_clicked;

     int vertex_selected;
     int x_old;
     int y_old;

};

#endif
